Index: /mods/mod_amazon/PayWithAmazon/Client.php
===================================================================
--- /mods/mod_amazon/PayWithAmazon/Client.php	(revision 7755)
+++ /mods/mod_amazon/PayWithAmazon/Client.php	(revision 7756)
@@ -821,18 +1076,19 @@
 
         $fieldMappings = array(
-            'merchant_id' 		=> 'SellerId',
+            'merchant_id'         => 'SellerId',
             'amazon_refund_id'  => 'AmazonRefundId',
-            'mws_auth_token' 	=> 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
-
-    /* GetServiceStatus API Call - Returns the operational status of the Off-Amazon Payments API section
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_GetServiceStatus.html
-     *
-     * The GetServiceStatus operation returns the operational status of the Off-Amazon Payments API
+            'mws_auth_token'     => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+
+        return ($responseObject);
+    }
+
+
+    /* GetServiceStatus API Call - Returns the operational status of the OffAmazonPayments API section
+     * @see https://pay.amazon.com/developer/documentation/apireference/201752110
+     *
+     * The GetServiceStatus operation returns the operational status of the OffAmazonPayments API
      * section of Amazon Marketplace Web Service (Amazon MWS).
      * Status values are GREEN, GREEN_I, YELLOW, and RED.
@@ -841,5 +1097,4 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function getServiceStatus($requestParameters = array())
     {
@@ -855,14 +1110,15 @@
         $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
 
-	return ($responseObject);
-    }
+        return ($responseObject);
+    }
+
 
     /* CreateOrderReferenceForId API Call - Creates an order reference for the given object
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_CreateOrderReferenceForId.html
-     *
-     * @param requestParameters['merchant_id'] - [String]
-     * @param requestParameters['Id'] - [String]
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751670
+     *
+     * @param requestParameters['merchant_id'] - [String]
+     * @param requestParameters['id'] - [String]
      * @optional requestParameters['inherit_shipping_address'] [Boolean]
-     * @optional requestParameters['ConfirmNow'] - [Boolean]
+     * @optional requestParameters['confirm_now'] - [Boolean]
      * @optional Amount (required when confirm_now is set to true) [String]
      * @optional requestParameters['currency_code'] - [String]
@@ -870,8 +1126,8 @@
      * @optional requestParameters['seller_order_id'] - [String]
      * @optional requestParameters['store_name'] - [String]
+     * @optional requestParameters['supplementary_data'] - [String]
      * @optional requestParameters['custom_information'] - [String]
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function createOrderReferenceForId($requestParameters = array())
     {
@@ -881,32 +1137,37 @@
 
         $fieldMappings = array(
-            'merchant_id' 				=> 'SellerId',
-            'id' 						=> 'Id',
-            'id_type' 					=> 'IdType',
-            'inherit_shipping_address' 	=> 'InheritShippingAddress',
-            'confirm_now' 				=> 'ConfirmNow',
-            'amount' 					=> 'OrderReferenceAttributes.OrderTotal.Amount',
-            'currency_code' 			=> 'OrderReferenceAttributes.OrderTotal.CurrencyCode',
-            'platform_id' 				=> 'OrderReferenceAttributes.PlatformId',
-            'seller_note' 				=> 'OrderReferenceAttributes.SellerNote',
-            'seller_order_id' 			=> 'OrderReferenceAttributes.SellerOrderAttributes.SellerOrderId',
-            'store_name' 				=> 'OrderReferenceAttributes.SellerOrderAttributes.StoreName',
-            'custom_information' 		=> 'OrderReferenceAttributes.SellerOrderAttributes.CustomInformation',
-            'mws_auth_token' 			=> 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'merchant_id'              => 'SellerId',
+            'id'                       => 'Id',
+            'id_type'                  => 'IdType',
+            'inherit_shipping_address' => 'InheritShippingAddress',
+            'confirm_now'              => 'ConfirmNow',
+            'amount'                   => 'OrderReferenceAttributes.OrderTotal.Amount',
+            'currency_code'            => 'OrderReferenceAttributes.OrderTotal.CurrencyCode',
+            'platform_id'              => 'OrderReferenceAttributes.PlatformId',
+            'seller_note'              => 'OrderReferenceAttributes.SellerNote',
+            'seller_order_id'          => 'OrderReferenceAttributes.SellerOrderAttributes.SellerOrderId',
+            'store_name'               => 'OrderReferenceAttributes.SellerOrderAttributes.StoreName',
+            'supplementary_data'       => 'OrderReferenceAttributes.SupplementaryData',
+            'custom_information'       => 'OrderReferenceAttributes.SellerOrderAttributes.CustomInformation',
+            'mws_auth_token'           => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* GetBillingAgreementDetails API Call - Returns details about the Billing Agreement object and its current state.
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_GetBillingAgreementDetails.html
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751690
      *
      * @param requestParameters['merchant_id'] - [String]
      * @param requestParameters['amazon_billing_agreement_id'] - [String]
-     * @optional requestParameters['mws_auth_token'] - [String]
-     */
-
+     * @optional requestParameters['address_consent_token'] - [String]
+     * @optional requestParameters['access_token'] - [String]
+     * @optional requestParameters['mws_auth_token'] - [String]
+     *
+     * You cannot pass both address_consent_token and access_token in
+     * the same call or you will encounter a 400/"AmbiguousToken" error
+     */
     public function getBillingAgreementDetails($requestParameters = array())
     {
@@ -916,17 +1177,18 @@
 
         $fieldMappings = array(
-            'merchant_id' 		  			=> 'SellerId',
-            'amazon_billing_agreement_id' 	=> 'AmazonBillingAgreementId',
-            'address_consent_token' 	  	=> 'AddressConsentToken',
-            'mws_auth_token' 		  		=> 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-	return ($responseObject);
-    }
+            'merchant_id'                 => 'SellerId',
+            'amazon_billing_agreement_id' => 'AmazonBillingAgreementId',
+            'address_consent_token'       => 'AddressConsentToken',
+            'access_token'                => 'AccessToken',
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* SetBillingAgreementDetails API call - Sets Billing Agreement details such as a description of the agreement and other information about the seller.
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_SetBillingAgreementDetails.html
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751700
      *
      * @param requestParameters['merchant_id'] - [String]
@@ -939,7 +1201,9 @@
      * @optional requestParameters['store_name'] - [String]
      * @optional requestParameters['custom_information'] - [String]
-     * @optional requestParameters['mws_auth_token'] - [String]
-     */
-
+     * @optional requestParameters['billing_agreement_type'] - [String] either 'CustomerInitiatedTransaction' or 'MerchantInitiatedTransaction'
+     * @optional requestParameters['subscription_amount'] - [String]
+     * @optional requestParameters['currency_code'] - [String]
+     * @optional requestParameters['mws_auth_token'] - [String]
+     */
     public function setBillingAgreementDetails($requestParameters = array())
     {
@@ -949,27 +1213,35 @@
 
         $fieldMappings = array(
-            'merchant_id' 		  => 'SellerId',
+            'merchant_id'                 => 'SellerId',
             'amazon_billing_agreement_id' => 'AmazonBillingAgreementId',
-            'platform_id' 		  => 'BillingAgreementAttributes.PlatformId',
-            'seller_note' 		  => 'BillingAgreementAttributes.SellerNote',
+            'platform_id'                 => 'BillingAgreementAttributes.PlatformId',
+            'seller_note'                 => 'BillingAgreementAttributes.SellerNote',
             'seller_billing_agreement_id' => 'BillingAgreementAttributes.SellerBillingAgreementAttributes.SellerBillingAgreementId',
-            'custom_information' 	  => 'BillingAgreementAttributes.SellerBillingAgreementAttributes.CustomInformation',
-            'store_name' 		  => 'BillingAgreementAttributes.SellerBillingAgreementAttributes.StoreName',
-            'mws_auth_token' 		  => 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'custom_information'          => 'BillingAgreementAttributes.SellerBillingAgreementAttributes.CustomInformation',
+            'store_name'                  => 'BillingAgreementAttributes.SellerBillingAgreementAttributes.StoreName',
+            'billing_agreement_type'      => 'BillingAgreementAttributes.BillingAgreementType',
+            'subscription_amount'         => 'BillingAgreementAttributes.SubscriptionAmount.Amount',
+            'currency_code'               => 'BillingAgreementAttributes.SubscriptionAmount.CurrencyCode',
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        if (isset($requestParameters['subscription_amount']) && !isset($requestParameters['currency_code'])) {
+            $requestParameters['currency_code'] = strtoupper($this->config['currency_code']);
+        }
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* ConfirmBillingAgreement API Call - Confirms that the Billing Agreement is free of constraints and all required information has been set on the Billing Agreement.
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_ConfirmBillingAgreement.html
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751710
      *
      * @param requestParameters['merchant_id'] - [String]
      * @param requestParameters['amazon_billing_agreement_id'] - [String]
-     * @optional requestParameters['mws_auth_token'] - [String]
-     */
-
+     * @optional requestParameters['success_url'] - [String]
+     * @optional requestParameters['failure_url'] - [String]
+     * @optional requestParameters['mws_auth_token'] - [String]
+     */
     public function confirmBillingAgreement($requestParameters = array())
     {
@@ -979,16 +1251,18 @@
 
         $fieldMappings = array(
-            'merchant_id' 		  => 'SellerId',
+            'merchant_id'                 => 'SellerId',
             'amazon_billing_agreement_id' => 'AmazonBillingAgreementId',
-            'mws_auth_token' 		  => 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'success_url'                 => 'SuccessUrl',
+            'failure_url'                 => 'FailureUrl',
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* ValidateBillignAgreement API Call - Validates the status of the Billing Agreement object and the payment method associated with it.
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_ValidateBillingAgreement.html
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751720
      *
      * @param requestParameters['merchant_id'] - [String]
@@ -996,5 +1270,4 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function validateBillingAgreement($requestParameters = array())
     {
@@ -1004,25 +1277,25 @@
 
         $fieldMappings = array(
-            'merchant_id' 		  => 'SellerId',
+            'merchant_id'                 => 'SellerId',
             'amazon_billing_agreement_id' => 'AmazonBillingAgreementId',
-            'mws_auth_token' 		  => 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* AuthorizeOnBillingAgreement API call - Reserves a specified amount against the payment method(s) stored in the Billing Agreement.
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_AuthorizeOnBillingAgreement.html
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751940
      *
      * @param requestParameters['merchant_id'] - [String]
      * @param requestParameters['amazon_billing_agreement_id'] - [String]
-     * @param requestParameters['authorization_reference_id'] [String]
-     * @param requestParameters['authorization_amount'] [String]
+     * @param requestParameters['authorization_reference_id'] - [String]
+     * @param requestParameters['authorization_amount'] - [String]
      * @param requestParameters['currency_code'] - [String]
      * @optional requestParameters['seller_authorization_note'] [String]
      * @optional requestParameters['transaction_timeout'] - Defaults to 1440 minutes
-     * @optional requestParameters['capture_now'] [String]
+     * @optional requestParameters['capture_now'] [Boolean]
      * @optional requestParameters['soft_descriptor'] - - [String]
      * @optional requestParameters['seller_note'] - [String]
@@ -1031,8 +1304,8 @@
      * @optional requestParameters['seller_order_id'] - [String]
      * @optional requestParameters['store_name'] - [String]
+     * @optional requestParameters['supplementary_data'] - [String]
      * @optional requestParameters['inherit_shipping_address'] [Boolean] - Defaults to true
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function authorizeOnBillingAgreement($requestParameters = array())
     {
@@ -1042,29 +1315,30 @@
 
         $fieldMappings = array(
-            'merchant_id' 			=> 'SellerId',
-            'amazon_billing_agreement_id' 	=> 'AmazonBillingAgreementId',
-            'authorization_reference_id' 	=> 'AuthorizationReferenceId',
-            'authorization_amount' 		=> 'AuthorizationAmount.Amount',
-            'currency_code' 			=> 'AuthorizationAmount.CurrencyCode',
-            'seller_authorization_note' 	=> 'SellerAuthorizationNote',
-            'transaction_timeout' 		=> 'TransactionTimeout',
-            'capture_now' 			=> 'CaptureNow',
-            'soft_descriptor' 			=> 'SoftDescriptor',
-            'seller_note' 			=> 'SellerNote',
-            'platform_id' 			=> 'PlatformId',
-            'custom_information' 		=> 'SellerOrderAttributes.CustomInformation',
-            'seller_order_id' 			=> 'SellerOrderAttributes.SellerOrderId',
-            'store_name' 			=> 'SellerOrderAttributes.StoreName',
-            'inherit_shipping_address' 		=> 'InheritShippingAddress',
-            'mws_auth_token' 			=> 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-	return ($responseObject);
-    }
+            'merchant_id'                 => 'SellerId',
+            'amazon_billing_agreement_id' => 'AmazonBillingAgreementId',
+            'authorization_reference_id'  => 'AuthorizationReferenceId',
+            'authorization_amount'        => 'AuthorizationAmount.Amount',
+            'currency_code'               => 'AuthorizationAmount.CurrencyCode',
+            'seller_authorization_note'   => 'SellerAuthorizationNote',
+            'transaction_timeout'         => 'TransactionTimeout',
+            'capture_now'                 => 'CaptureNow',
+            'soft_descriptor'             => 'SoftDescriptor',
+            'seller_note'                 => 'SellerNote',
+            'platform_id'                 => 'PlatformId',
+            'custom_information'          => 'SellerOrderAttributes.CustomInformation',
+            'seller_order_id'             => 'SellerOrderAttributes.SellerOrderId',
+            'store_name'                  => 'SellerOrderAttributes.StoreName',
+            'supplementary_data'          => 'SellerOrderAttributes.SupplementaryData',
+            'inherit_shipping_address'    => 'InheritShippingAddress',
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* CloseBillingAgreement API Call - Returns details about the Billing Agreement object and its current state.
-     * @see http://docs.developer.amazonservices.com/en_US/off_amazon_payments/OffAmazonPayments_CloseBillingAgreement.html
+     * @see https://pay.amazon.com/developer/documentation/apireference/201751950
      *
      * @param requestParameters['merchant_id'] - [String]
@@ -1073,5 +1347,4 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function closeBillingAgreement($requestParameters = array())
     {
@@ -1081,14 +1354,58 @@
 
         $fieldMappings = array(
-            'merchant_id' 		  => 'SellerId',
+            'merchant_id'                 => 'SellerId',
             'amazon_billing_agreement_id' => 'AmazonBillingAgreementId',
-            'closure_reason' 		  => 'ClosureReason',
-            'mws_auth_token' 		  => 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'closure_reason'              => 'ClosureReason',
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
+
+    /* GetMerchantNotificationConfiguration API Call - Returns details about the defined IPN endpoints
+     *
+     * @param requestParameters['merchant_id'] - [String]
+     * @optional requestParameters['mws_auth_token'] - [String]
+     */
+    public function getMerchantNotificationConfiguration($requestParameters = array())
+    {
+        $parameters           = array();
+        $parameters['Action'] = 'GetMerchantNotificationConfiguration';
+        $requestParameters    = array_change_key_case($requestParameters, CASE_LOWER);
+
+        $fieldMappings = array(
+            'merchant_id'                 => 'SellerId',
+            'mws_auth_token'              => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
+
+    /* SetMerchantNotificationConfiguration API Call - Set IPN endpoints
+     *
+     * @param requestParameters['merchant_id'] - [String]
+     * @param requestParameters['notification_configuration_list'] - [Array]
+     * @optional requestParameters['mws_auth_token'] - [String]
+     */
+    public function setMerchantNotificationConfiguration($requestParameters = array())
+    {
+        $parameters           = array();
+        $parameters['Action'] = 'SetMerchantNotificationConfiguration';
+        $requestParameters    = array_change_key_case($requestParameters, CASE_LOWER);
+
+        $fieldMappings = array(
+            'merchant_id'                     => 'SellerId',
+            'notification_configuration_list' => array(),
+            'mws_auth_token'                  => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* charge convenience method
@@ -1114,22 +1431,19 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function charge($requestParameters = array()) {
 
-	$requestParameters = array_change_key_case($requestParameters, CASE_LOWER);
-	$requestParameters= $this->trimArray($requestParameters);
-
-	$setParameters = $authorizeParameters = $confirmParameters = $requestParameters;
+        $requestParameters = array_change_key_case($requestParameters, CASE_LOWER);
+        $requestParameters = $this->trimArray($requestParameters);
+
+        $setParameters = $authorizeParameters = $confirmParameters = $requestParameters;
 
         $chargeType = '';
-	
-	if (!empty($requestParameters['amazon_order_reference_id']))
-	{
-	    $chargeType = 'OrderReference';
-	    
-	} elseif(!empty($requestParameters['amazon_billing_agreement_id'])) {
-	    $chargeType = 'BillingAgreement';
-	    
-	} elseif (!empty($requestParameters['amazon_reference_id'])) {
+    
+        if (!empty($requestParameters['amazon_order_reference_id'])) {
+            $chargeType = 'OrderReference';
+        } elseif (!empty($requestParameters['amazon_billing_agreement_id'])) {
+            $chargeType = 'BillingAgreement';
+        
+        } elseif (!empty($requestParameters['amazon_reference_id'])) {
             switch (substr(strtoupper($requestParameters['amazon_reference_id']), 0, 1)) {
                 case 'P':
@@ -1154,5 +1468,5 @@
         }
 
-	// Set the other parameters if the values are present
+        // Set the other parameters if the values are present
         $setParameters['amount'] = !empty($requestParameters['charge_amount']) ? $requestParameters['charge_amount'] : '';
         $authorizeParameters['authorization_amount'] = !empty($requestParameters['charge_amount']) ? $requestParameters['charge_amount'] : '';
@@ -1168,57 +1482,58 @@
         $authorizeParameters['capture_now'] = !empty($requestParameters['capture_now']) ? $requestParameters['capture_now'] : false;
 
-	$response = $this->makeChargeCalls($chargeType, $setParameters, $confirmParameters, $authorizeParameters);
-	return $response;
-    }
+        $response = $this->makeChargeCalls($chargeType, $setParameters, $confirmParameters, $authorizeParameters);
+        return $response;
+    }
+
 
     /* makeChargeCalls - makes API calls based off the charge type (OrderReference or BillingAgreement) */
-
     private function makeChargeCalls($chargeType, $setParameters, $confirmParameters, $authorizeParameters)
     {
-	switch ($chargeType) {
+        switch ($chargeType) {
             
-	    case 'OrderReference':
-		
-		// Get the Order Reference details and feed the response object to the ResponseParser
+            case 'OrderReference':
+        
+                // Get the Order Reference details and feed the response object to the ResponseParser
                 $responseObj = $this->getOrderReferenceDetails($setParameters);
-		
-		// Call the function getOrderReferenceDetailsStatus in ResponseParser.php providing it the XML response
-                // $oroStatus is an array containing the State of the Order Reference ID
+        
+               // Call the function getOrderReferenceDetailsStatus in ResponseParser.php providing it the XML response
+               // $oroStatus is an array containing the State of the Order Reference ID
+               $oroStatus = $responseObj->getOrderReferenceDetailsStatus($responseObj->toXml());
+        
+                if ($oroStatus['State'] === 'Draft') {
+                    $response = $this->setOrderReferenceDetails($setParameters);
+                    if ($this->success) {
+                        $this->confirmOrderReference($confirmParameters);
+                    }
+                }
+        
+                $responseObj = $this->getOrderReferenceDetails($setParameters);
+        
+                // Check the Order Reference Status again before making the Authorization.
                 $oroStatus = $responseObj->getOrderReferenceDetailsStatus($responseObj->toXml());
-		
-		if ($oroStatus['State'] === 'Draft') {
-		    $response = $this->setOrderReferenceDetails($setParameters);
-		    if ($this->success) {
-                    $this->confirmOrderReference($confirmParameters);
-		    }
-		}
-		
-                $responseObj = $this->getOrderReferenceDetails($setParameters);
-		
-		// Check the Order Reference Status again before making the Authorization.
-                $oroStatus = $responseObj->getOrderReferenceDetailsStatus($responseObj->toXml());
-		
-		if ($oroStatus['State'] === 'Open') {
-		    if ($this->success) {
-                    $response = $this->Authorize($authorizeParameters);
-		    }
-		}
-		if ($oroStatus['State'] != 'Open' && $oroStatus['State'] != 'Draft') {
-		    throw new \Exception('The Order Reference is in the ' . $oroStatus['State'] . " State. It should be in the Draft or Open State");
-		}
+        
+                if ($oroStatus['State'] === 'Open') {
+                    if ($this->success) {
+                        $response = $this->authorize($authorizeParameters);
+                    }
+                }
+
+                if ($oroStatus['State'] != 'Open' && $oroStatus['State'] != 'Draft') {
+                    throw new \Exception('The Order Reference is in the ' . $oroStatus['State'] . " State. It should be in the Draft or Open State");
+                }
                 
-		return $response;
+                return $response;
             
-	    case 'BillingAgreement':
+            case 'BillingAgreement':
                 
-		// Get the Billing Agreement details and feed the response object to the ResponseParser
+                // Get the Billing Agreement details and feed the response object to the ResponseParser
                 
-		$responseObj = $this->getBillingAgreementDetails($setParameters);
+                $responseObj = $this->getBillingAgreementDetails($setParameters);
                 
-		// Call the function getBillingAgreementDetailsStatus in ResponseParser.php providing it the XML response
+                // Call the function getBillingAgreementDetailsStatus in ResponseParser.php providing it the XML response
                 // $baStatus is an array containing the State of the Billing Agreement
                 $baStatus = $responseObj->getBillingAgreementDetailsStatus($responseObj->toXml());
                 
-		if ($baStatus['State'] === 'Draft') {
+                if ($baStatus['State'] === 'Draft') {
                     $response = $this->setBillingAgreementDetails($setParameters);
                     if ($this->success) {
@@ -1227,19 +1542,23 @@
                 }
                 
-		// Check the Billing Agreement status again before making the Authorization.
+                // Check the Billing Agreement status again before making the Authorization.
                 $responseObj = $this->getBillingAgreementDetails($setParameters);
                 $baStatus = $responseObj->getBillingAgreementDetailsStatus($responseObj->toXml());
-		
+        
                 if ($this->success && $baStatus['State'] === 'Open') {
                     $response = $this->authorizeOnBillingAgreement($authorizeParameters);
                 }
-		
-		if($baStatus['State'] != 'Open' && $baStatus['State'] != 'Draft') {
-		    throw new \Exception('The Billing Agreement is in the ' . $baStatus['State'] . " State. It should be in the Draft or Open State");
-		}
-		
-            return $response;
-	    }
-	}
+        
+                if ($baStatus['State'] != 'Open' && $baStatus['State'] != 'Draft') {
+                    throw new \Exception('The Billing Agreement is in the ' . $baStatus['State'] . " State. It should be in the Draft or Open State");
+                }
+        
+                return $response;
+
+            default:
+                throw new \Exception('Invalid Charge Type');
+        }
+    }
+
 
     /* GetProviderCreditDetails API Call - Get the details of the Provider Credit.
@@ -1249,21 +1568,20 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function getProviderCreditDetails($requestParameters = array())
     {
-	$parameters           = array();
+        $parameters           = array();
         $parameters['Action'] = 'GetProviderCreditDetails';
         $requestParameters    = array_change_key_case($requestParameters, CASE_LOWER);
 
         $fieldMappings = array(
-            'merchant_id' 		=> 'SellerId',
+            'merchant_id'               => 'SellerId',
             'amazon_provider_credit_id' => 'AmazonProviderCreditId',
-            'mws_auth_token' 		=> 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'mws_auth_token'            => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* GetProviderCreditReversalDetails API Call - Get details of the Provider Credit Reversal.
@@ -1273,21 +1591,20 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function getProviderCreditReversalDetails($requestParameters = array())
     {
-	$parameters           = array();
+        $parameters           = array();
         $parameters['Action'] = 'GetProviderCreditReversalDetails';
         $requestParameters    = array_change_key_case($requestParameters, CASE_LOWER);
 
         $fieldMappings = array(
-            'merchant_id' 		  	 => 'SellerId',
+            'merchant_id'                        => 'SellerId',
             'amazon_provider_credit_reversal_id' => 'AmazonProviderCreditReversalId',
-            'mws_auth_token' 		  	 => 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'mws_auth_token'                     => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* ReverseProviderCredit API Call - Reverse the Provider Credit.
